﻿local agony, corruption, ua 		= 0, 0, 0;					-- dot power based on current stats
local mastery, haste, crit, spd 	= 0, 0, 0, 0;				-- current stats
local agony_targets 				= {};						-- array of targets with agony on them
local corruption_targets 			= {};						
local ua_targets 					= {};						
local target_id 					= false;						-- current target GUID
local focus_id						= false;						-- focus target GUID
local me 							= false;						-- player GUID

local timer 						= 0;

local agony_name					= GetSpellInfo(980);
local corruption_name				= GetSpellInfo(172);
local ua_name						= GetSpellInfo(30108);
local haunt_name					= GetSpellInfo(48181);

local shards						= 0;
local agony_bonus					= 1;
local corruption_bonus				= 1;						--2T14 set bonus
local ua_bonus						= 1;

local event_type,source_GUID,dest_GUID,spell;					-- reassigning values probably faster than redefining variables
local colors

function Round(num)
	return math.floor(num+.5)
end

-- FRAMES
local m		= AffDotsFrame
m.agony = AgonyFrame
m.corr	= CorrFrame
m.ua	= UAFrame
m.haunt	= HauntFrame

m.agony.texture = m.agony:CreateTexture()
m.agony.texture:SetAllPoints(m.agony)
m.agony.texture:SetTexture(0,0,0,0.5)
m.corr.texture = m.corr:CreateTexture()
m.corr.texture:SetAllPoints(m.corr)
m.corr.texture:SetTexture(0,0,0,0.5)
m.ua.texture = m.ua:CreateTexture()
m.ua.texture:SetAllPoints(m.ua)
m.ua.texture:SetTexture(0,0,0,0.5)
m.haunt.texture = m.haunt:CreateTexture()
m.haunt.texture:SetAllPoints(m.haunt)
m.haunt.texture:SetTexture(0,0,0,0.5)

m.agony.t1 = AgonyT1
m.agony.t2 = AgonyT2
m.agony.t3 = AgonyT3
m.corr.t1 = CorrT1
m.corr.t2 = CorrT2
m.corr.t3 = CorrT3
m.ua.t1 = UAT1
m.ua.t2 = UAT2
m.ua.t3 = UAT3
m.haunt.t1 = HauntT1
m.haunt.t1:SetTextHeight(20)
m.agony.icon = AgonyIcon
m.corr.icon = CorrIcon
m.ua.icon = UAIcon
m.haunt.icon = HauntIcon

m.agony.cd = CreateFrame("Cooldown", nil, m.agony)
m.agony.cd:SetAllPoints(AgonyIcon)
m.corr.cd = CreateFrame("Cooldown", nil, m.corr)
m.corr.cd:SetAllPoints(CorrIcon)
m.ua.cd = CreateFrame("Cooldown", nil, m.ua)
m.ua.cd:SetAllPoints(UAIcon)
m.haunt.cd = CreateFrame("Cooldown", nil, m.haunt)
m.haunt.cd:SetAllPoints(HauntIcon)

m:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" and not self.isMoving then
		self:StartMoving();
		self.isMoving = true;
	end
end)
m:SetScript("OnMouseUp", function(self, button)
	local p,_,rp, x, y = self:GetPoint();
	AffDotsOpt.p = p;
	AffDotsOpt.rp = rp;
	AffDotsOpt.x = x;
	AffDotsOpt.y = y;
	if button == "LeftButton" and self.isMoving then
		self:StopMovingOrSizing();
		self:SetUserPlaced(false)
		self.isMoving = false;
	end
end)


local f		= AffDotsFocus
f.agony	= AgonyFocus	
f.corr	= CorrFocus
f.ua	= UAFocus

f.agony.texture = f.agony:CreateTexture()
f.agony.texture:SetAllPoints(f.agony)
f.agony.texture:SetTexture(0,0,0,0.5)
f.corr.texture = f.corr:CreateTexture()
f.corr.texture:SetAllPoints(f.corr)
f.corr.texture:SetTexture(0,0,0,0.5)
f.ua.texture = f.ua:CreateTexture()
f.ua.texture:SetAllPoints(f.ua)
f.ua.texture:SetTexture(0,0,0,0.5)

f.agony.cd = CreateFrame("Cooldown", nil, f.agony)
f.agony.cd:SetAllPoints(AgonyFIcon)
f.corr.cd = CreateFrame("Cooldown", nil, f.corr)
f.corr.cd:SetAllPoints(CorrFIcon)
f.ua.cd = CreateFrame("Cooldown", nil, f.ua)
f.ua.cd:SetAllPoints(UAFIcon)

f.agony.t1 = AgonyFT1
f.agony.t2 = AgonyFT2
f.agony.t3 = AgonyFT3
f.corr.t1 = CorrFT1
f.corr.t2 = CorrFT2
f.corr.t3 = CorrFT3
f.ua.t1 = UAFT1
f.ua.t2 = UAFT2
f.ua.t3 = UAFT3
f.agony.icon = AgonyFIcon
f.corr.icon = CorrFIcon
f.ua.icon = UAFIcon

f:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" and not self.isMoving then
		self:StartMoving();
		self.isMoving = true;
	end
end)
f:SetScript("OnMouseUp", function(self, button)
	local p,_,rp, x, y = self:GetPoint();
	AffDotsOpt.focus_p = p;
	AffDotsOpt.focus_rp = rp;
	AffDotsOpt.focus_x = x;
	AffDotsOpt.focus_y = y;
	if button == "LeftButton" and self.isMoving then
		self:StopMovingOrSizing();
		self:SetUserPlaced(false)
		self.isMoving = false;
	end
end)

m:SetUserPlaced(false)
f:SetUserPlaced(false)

function TextOptions()
	if(AffDotsOpt.main_text == "absolute") then
		m.agony.t1:Show();m.corr.t1:Show()m.ua.t1:Show()
		m.agony.t2:Show();m.corr.t2:Show()m.ua.t2:Show()
		m.agony.t3:Hide();m.corr.t3:Hide()m.ua.t3:Hide()
	else
		m.agony.t1:Hide();m.corr.t1:Hide()m.ua.t1:Hide()
		m.agony.t2:Hide();m.corr.t2:Hide()m.ua.t2:Hide()
		m.agony.t3:Show();m.corr.t3:Show()m.ua.t3:Show()
	end
	if(AffDotsOpt.focus_text == "absolute") then
		f.agony.t1:Show();f.corr.t1:Show()f.ua.t1:Show()
		f.agony.t2:Show();f.corr.t2:Show()f.ua.t2:Show()
		f.agony.t3:Hide();f.corr.t3:Hide()f.ua.t3:Hide()
	else
		f.agony.t1:Hide();f.corr.t1:Hide()f.ua.t1:Hide()
		f.agony.t2:Hide();f.corr.t2:Hide()f.ua.t2:Hide()
		f.agony.t3:Show();f.corr.t3:Show()f.ua.t3:Show()
	end
end

function Unlock(unlock)
	m:SetMovable(unlock);
	m:EnableMouse(unlock);
	f:SetMovable(unlock);
	f:EnableMouse(unlock);
end

function Hide(hide)
	if(hide and AffDotsOpt.hide) then
		if not InCombatLockdown() then m:Hide();f:Hide(); end
	else
		m:Show()
		f:Show()
	end
end

function AffDotsOpenColorPicker( b, c )
	ColorPickerFrame:Hide()
	button = b
	color_type = c
	ColorPickerFrame:SetColorRGB(colors[color_type][1], colors[color_type][2], colors[color_type][3])
	restore = colors[color_type]

	ColorPickerFrame.func =
		function ()
			local r,g,b = ColorPickerFrame:GetColorRGB()
			if 		color_type==1 then AffDotsOpt.color1 = {r,g,b}; colors[1] = {r,g,b};
			elseif 	color_type==2 then AffDotsOpt.color2 = {r,g,b}; colors[2] = {r,g,b};
			elseif 	color_type==3 then AffDotsOpt.color3 = {r,g,b}; colors[3] = {r,g,b};
			elseif 	color_type==4 then AffDotsOpt.color4 = {r,g,b}; colors[4] = {r,g,b};
			elseif 	color_type==5 then AffDotsOpt.color5 = {r,g,b}; colors[5] = {r,g,b};
			end
			getglobal(button:GetName() .. "Color"):SetVertexColor(r,g,b)
		end
	ColorPickerFrame.cancelFunc =
		function ()
			if 		color_type==1 then AffDotsOpt.color1 = restore; colors[1] = restore;
			elseif 	color_type==2 then AffDotsOpt.color2 = restore; colors[2] = restore;
			elseif 	color_type==3 then AffDotsOpt.color3 = restore; colors[3] = restore;
			elseif 	color_type==4 then AffDotsOpt.color4 = restore; colors[4] = restore;
			elseif 	color_type==5 then AffDotsOpt.color5 = restore; colors[5] = restore;
			end
			getglobal(button:GetName() .. "Color"):SetVertexColor(colors[color_type][1], colors[color_type][2], colors[color_type][3])
		end
	ColorPickerFrame:Show()
end

function OptionsFrameFunctions()
	AffDotsOptHide:SetChecked(AffDotsOpt.hide)
	AffDotsOptHorizontal:SetChecked(AffDotsOpt.layout=="horizontal")
	AffDotsOptHaunt:SetChecked(AffDotsOpt.haunt)
	AffDotsOptFocus:SetChecked(AffDotsOpt.focus)
	AffDotsOptTextType:SetChecked(AffDotsOpt.main_text=="relative")
	AffDotsOptScaleSlider:SetValue(AffDotsOpt.scale)
	getglobal(AffDotsOptScaleSlider:GetName() .. 'Text'):SetText(AffDotsOpt.scale)
	AffDotsOptFScaleSlider:SetValue(AffDotsOpt.focus_scale)
	getglobal(AffDotsOptFScaleSlider:GetName() .. 'Text'):SetText(AffDotsOpt.focus_scale)
	AffDotsOptColorSwitch:SetValue((AffDotsOpt.color_switch-1)*100)
	getglobal(AffDotsOptColorSwitch:GetName() .. 'Text'):SetText((AffDotsOpt.color_switch-1)*100)
	AffDotsOptAlpha:SetValue(AffDotsOpt.transparency)
	getglobal(AffDotsOptAlpha:GetName() .. 'Text'):SetText(AffDotsOpt.transparency)
	AffDotsOptOrderAgony:SetValue(AffDotsOpt.agony_order+1)
	getglobal(AffDotsOptOrderAgony:GetName() .. 'Text'):SetText(AffDotsOpt.agony_order+1)
	AffDotsOptOrderCorr:SetValue(AffDotsOpt.corruption_order+1)
	getglobal(AffDotsOptOrderCorr:GetName() .. 'Text'):SetText(AffDotsOpt.corruption_order+1)
	AffDotsOptOrderUA:SetValue(AffDotsOpt.ua_order+1)
	getglobal(AffDotsOptOrderUA:GetName() .. 'Text'):SetText(AffDotsOpt.ua_order+1)
	AffDotsOptOrderHaunt:SetValue(AffDotsOpt.haunt_order+1)
	getglobal(AffDotsOptOrderHaunt:GetName() .. 'Text'):SetText(AffDotsOpt.haunt_order+1)
	getglobal(AffDotsOptColor1:GetName() .. "Color"):SetVertexColor(colors[1][1], colors[1][2], colors[1][3])
	getglobal(AffDotsOptColor2:GetName() .. "Color"):SetVertexColor(colors[2][1], colors[2][2], colors[2][3])
	getglobal(AffDotsOptColor3:GetName() .. "Color"):SetVertexColor(colors[3][1], colors[3][2], colors[3][3])
	getglobal(AffDotsOptColor4:GetName() .. "Color"):SetVertexColor(colors[4][1], colors[4][2], colors[4][3])
	getglobal(AffDotsOptColor5:GetName() .. "Color"):SetVertexColor(colors[5][1], colors[5][2], colors[5][3])
	AffDotsOptions:EnableMouse(true)
	AffDotsOptions:SetMovable(true)
	AffDotsOptions:RegisterForDrag("LeftButton")
	AffDotsOptions:SetScript("OnDragStart", function(self) self:StartMoving() end)
	AffDotsOptions:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing()
		self:SetUserPlaced(false)
	end)

	AffDotsOptHide:SetScript("OnClick", function(self)
		AffDotsOpt.hide = not AffDotsOpt.hide;
		Hide()
	end)

	AffDotsOptHorizontal:SetScript("OnClick", function(self)
		if(AffDotsOpt.layout == "horizontal") then
			AffDotsOpt.layout = "vertical"
		else
			AffDotsOpt.layout = "horizontal"
		end
		Layout()
	end)

	AffDotsOptHaunt:SetScript("OnClick", function(self)
		AffDotsOpt.haunt = not AffDotsOpt.haunt;
		Layout();
	end)

	AffDotsOptFocus:SetScript("OnClick", function(self)
		AffDotsOpt.focus = not AffDotsOpt.focus;
		if(AffDotsOpt.focus) then
			m:RegisterEvent("PLAYER_FOCUS_CHANGED")
		else
			m:UnregisterEvent("PLAYER_FOCUS_CHANGED")
		end
		Layout();
	end)
	
	AffDotsOptTextType:SetScript("OnClick", function(self)
		if(AffDotsOpt.main_text == "absolute") then
			AffDotsOpt.main_text = "relative"
			AffDotsOpt.focus_text = "relative"
		else
			AffDotsOpt.main_text = "absolute"
			AffDotsOpt.focus_text = "absolute"
		end
		TextOptions()
		Layout()
	end)

	AffDotsOptScaleSlider:SetScript("OnValueChanged", function()
		AffDotsOpt.scale = Round(AffDotsOptScaleSlider:GetValue()*10)/10
		getglobal(AffDotsOptScaleSlider:GetName() .. 'Text'):SetText(AffDotsOpt.scale)
		Layout()
	end)

	AffDotsOptFScaleSlider:SetScript("OnValueChanged", function()
		AffDotsOpt.focus_scale = Round(AffDotsOptFScaleSlider:GetValue()*10)/10
		getglobal(AffDotsOptFScaleSlider:GetName() .. 'Text'):SetText(AffDotsOpt.focus_scale)
		Layout()
	end)
	
	AffDotsOptAlpha:SetScript("OnValueChanged", function()
		AffDotsOpt.transparency = Round(AffDotsOptAlpha:GetValue()*10)/10
		getglobal(AffDotsOptAlpha:GetName() .. 'Text'):SetText(AffDotsOpt.transparency)
		Layout()
	end)

	AffDotsOptOrderHaunt:SetScript("OnValueChanged", function()
		AffDotsOpt.haunt_order = Round(AffDotsOptOrderHaunt:GetValue())-1
		getglobal(AffDotsOptOrderHaunt:GetName() .. 'Text'):SetText(Round(AffDotsOptOrderHaunt:GetValue()))
		Layout();
	end)

	AffDotsOptOrderAgony:SetScript("OnValueChanged", function()
		AffDotsOpt.agony_order = Round(AffDotsOptOrderAgony:GetValue())-1
		getglobal(AffDotsOptOrderAgony:GetName() .. 'Text'):SetText(Round(AffDotsOptOrderAgony:GetValue()))
		Layout();
	end)

	AffDotsOptOrderCorr:SetScript("OnValueChanged", function()
		AffDotsOpt.corruption_order = Round(AffDotsOptOrderCorr:GetValue())-1
		getglobal(AffDotsOptOrderCorr:GetName() .. 'Text'):SetText(Round(AffDotsOptOrderCorr:GetValue()))
		Layout();
	end)

	AffDotsOptOrderUA:SetScript("OnValueChanged", function()
		AffDotsOpt.ua_order = Round(AffDotsOptOrderUA:GetValue())-1
		getglobal(AffDotsOptOrderUA:GetName() .. 'Text'):SetText(Round(AffDotsOptOrderUA:GetValue()))
		Layout();
	end)

	AffDotsOptColorSwitch:SetScript("OnValueChanged", function()
		AffDotsOpt.color_switch = 1 + Round(AffDotsOptColorSwitch:GetValue())/100
		getglobal(AffDotsOptColorSwitch:GetName() .. 'Text'):SetText((AffDotsOpt.color_switch-1)*100);
	end)

	AffDotsOptReset:SetScript("OnClick", function()
		AffDotsOpt.x = nil
		AffDotsOpt.y = nil
		AffDotsOpt.p = nil
		AffDotsOpt.rp = nil
		AffDotsOpt.focus_x = nil
		AffDotsOpt.focus_y = nil
		AffDotsOpt.focus_p = nil
		AffDotsOpt.focus_rp = nil
		Layout()
	end)
	
	AffDotsOptClose:SetScript("OnClick", function()
		AffDotsOptions:Hide()
		if(not AffDotsOpt.focus) then f:Hide(); end
		Unlock(false)
		Hide(true)
	end)
end

function HorizontalLayout(frame, scale)
	frame:SetSize(80*scale, 160*scale);
	frame.agony:SetSize(80, 40);
	frame.corr:SetSize(80, 40);
	frame.ua:SetSize(80, 40);
	frame.agony:SetPoint("TOPLEFT", 0, AffDotsOpt.agony_order*-40);
	frame.corr:SetPoint("TOPLEFT", 0, AffDotsOpt.corruption_order*-40);
	frame.ua:SetPoint("TOPLEFT", 0, AffDotsOpt.ua_order*-40);
	frame.agony.t1:SetPoint("TOPRIGHT", -7, -8);
	frame.agony.t2:SetPoint("TOPRIGHT", -7, -23);
	frame.agony.t3:SetPoint("TOPRIGHT", -8, -13);
	frame.corr.t1:SetPoint("TOPRIGHT", -7, -8);
	frame.corr.t2:SetPoint("TOPRIGHT", -7, -23);
	frame.corr.t3:SetPoint("TOPRIGHT", -8, -13);
	frame.ua.t1:SetPoint("TOPRIGHT", -7, -8);
	frame.ua.t2:SetPoint("TOPRIGHT", -7, -23);
	frame.ua.t3:SetPoint("TOPRIGHT", -8, -13);
	frame.agony.icon:SetPoint("TOPLEFT", 5, -5);
	frame.corr.icon:SetPoint("TOPLEFT", 5, -5);
	frame.ua.icon:SetPoint("TOPLEFT", 5, -5);
	frame.agony:SetScale(scale);
	frame.corr:SetScale(scale);
	frame.ua:SetScale(scale);
end

function VerticalLayout(frame, scale)
	frame:SetSize(160*scale, 70*scale);
	frame.agony:SetSize(40, 70);
	frame.corr:SetSize(40, 70);
	frame.ua:SetSize(40, 70);
	frame.agony:SetPoint("TOPLEFT", AffDotsOpt.agony_order*40, 0);
	frame.corr:SetPoint("TOPLEFT", AffDotsOpt.corruption_order*40, 0);
	frame.ua:SetPoint("TOPLEFT", AffDotsOpt.ua_order*40, 0);
	frame.agony.t1:SetPoint("TOPRIGHT", -5, -5);
	frame.agony.t2:SetPoint("TOPRIGHT", -5, -20);
	frame.agony.t3:SetPoint("TOPRIGHT", -5, -13);
	frame.corr.t1:SetPoint("TOPRIGHT", -5, -5);
	frame.corr.t2:SetPoint("TOPRIGHT", -5, -20);
	frame.corr.t3:SetPoint("TOPRIGHT", -5, -13);
	frame.ua.t1:SetPoint("TOPRIGHT", -5, -5);
	frame.ua.t2:SetPoint("TOPRIGHT", -5, -20);
	frame.ua.t3:SetPoint("TOPRIGHT", -5, -13);
	frame.agony.icon:SetPoint("TOPLEFT", 5, -35);
	frame.corr.icon:SetPoint("TOPLEFT", 5, -35);
	frame.ua.icon:SetPoint("TOPLEFT", 5, -35);
	frame.agony:SetScale(scale);
	frame.corr:SetScale(scale);
	frame.ua:SetScale(scale);
end

function Layout()
	TextOptions()
	if(AffDotsOpt.x and AffDotsOpt.y and AffDotsOpt.p and AffDotsOpt.rp) then
		m:SetPoint(AffDotsOpt.p, nil, AffDotsOpt.rp, AffDotsOpt.x, AffDotsOpt.y)
	else
		m:SetPoint("CENTER", 0, 0)
	end
	if(AffDotsOpt.focus_x and AffDotsOpt.focus_y and AffDotsOpt.focus_p and AffDotsOpt.focus_rp) then
		f:SetPoint(AffDotsOpt.focus_p, nil, AffDotsOpt.focus_rp, AffDotsOpt.focus_x, AffDotsOpt.focus_y)
	else
		f:SetPoint("CENTER", 0, 0)
	end
	if AffDotsOpt.layout == "horizontal" then
		HorizontalLayout(m, AffDotsOpt.scale)
		HorizontalLayout(f, AffDotsOpt.focus_scale)
		m.haunt:SetSize(80, 40);
		m.haunt:SetPoint("TOPLEFT", 0, AffDotsOpt.haunt_order*-40);
		m.haunt.icon:SetPoint("TOPLEFT", 5, -5);
		m.haunt.t1:SetPoint("TOP", 17, -10);
		m.haunt:SetScale(AffDotsOpt.scale)
	else
		VerticalLayout(m, AffDotsOpt.scale)
		VerticalLayout(f, AffDotsOpt.focus_scale)
		m.haunt:SetSize(40, 70);
		m.haunt:SetPoint("TOPLEFT", AffDotsOpt.haunt_order*40, 0);
		m.haunt.icon:SetPoint("TOPLEFT", 5, -35);
		m.haunt.t1:SetPoint("TOP", 0, -10);
		m.haunt:SetScale(AffDotsOpt.scale)
	end
	if(not AffDotsOpt.haunt) then m.haunt:Hide()
	else m.haunt:Show()
	end
end



function GetDotDmg()
	local damage_bonus = (1+crit/100)*(1+mastery/100);
	local haste_bonus = 2/(1+haste/100);
	local agony_ticks = Round(24/haste_bonus);
	local corruption_ticks = Round(18/haste_bonus);
	local ua_ticks = Round(14/haste_bonus);
	agony = Round((agony_ticks*(280+spd*0.26)*damage_bonus*agony_bonus)/1000);
	corruption = Round(((1926+corruption_ticks*spd*0.2)*damage_bonus*corruption_bonus)/1000);
	ua = Round(((1792+ua_ticks*spd*0.24)*damage_bonus*ua_bonus)/1000);
	
	if(AffDotsOpt.main_text == "absolute") then
		m.agony.t1:SetText(agony);
		m.corr.t1:SetText(corruption);
		m.ua.t1:SetText(ua);
	end
	if(AffDotsOpt.focus and AffDotsOpt.focus_text == "absolute") then
		f.agony.t1:SetText(agony);
		f.corr.t1:SetText(corruption);
		f.ua.t1:SetText(ua);
	end
end

function SetFrame(frame, cd_frame, debuff_name, t, t_id, array, pandemic_bonus, debuff)
	if not t_id then return end
	local time_now = GetTime()
	local _,_,_,_,_,duration,expires = UnitDebuff(t, debuff_name,"","player");
	if(expires and array[t_id]) then
		local duration_left = expires - time_now;
		cd_frame:SetCooldown(expires-duration, duration)
		if(array[t_id][1]*AffDotsOpt.color_switch >= debuff and duration_left>pandemic_bonus) then
			frame.texture:SetTexture(colors[4][1],colors[4][2],colors[4][3],AffDotsOpt.transparency)
		elseif(array[tostring(t_id)][1] >= debuff) then
			frame.texture:SetTexture(colors[3][1],colors[3][2],colors[3][3],AffDotsOpt.transparency);
		elseif(array[tostring(t_id)][1]*AffDotsOpt.color_switch < debuff and duration_left > pandemic_bonus) then
			frame.texture:SetTexture(colors[2][1],colors[2][2],colors[2][3],AffDotsOpt.transparency);
		else
			frame.texture:SetTexture(colors[1][1],colors[1][2],colors[1][3],AffDotsOpt.transparency);
		end
	else
		cd_frame:Hide();
		frame.texture:SetTexture(colors[5][1],colors[5][2],colors[5][3],AffDotsOpt.transparency);
	end
end

function SetFrames()
	SetFrame(m.agony, m.agony.cd, agony_name, "target", target_id, agony_targets, 12, agony)
	SetFrame(m.corr, m.corr.cd, corruption_name, "target", target_id, corruption_targets, 9, corruption)
	SetFrame(m.ua, m.ua.cd, ua_name, "target", target_id, ua_targets, 7, ua)
	
	if(AffDotsOpt.focus and focus_id) then
		SetFrame(f.agony, f.agony.cd, agony_name, "focus", focus_id, agony_targets, 12, agony)
		SetFrame(f.corr, f.corr.cd, corruption_name, "focus", focus_id, corruption_targets, 9, corruption)
		SetFrame(f.ua, f.ua.cd, ua_name, "focus", focus_id, ua_targets, 7, ua)
	end
	
	if(AffDotsOpt.haunt) then
		local time_now = GetTime();
		local duration_left;
		local _,_,_,_,_,duration,expires = UnitDebuff("target", haunt_name,"","player");
		if(expires) then
			m.haunt.cd:SetCooldown(expires-duration, duration);
			m.haunt.cd:Show();
			m.haunt.texture:SetTexture(colors[5][1],colors[5][2],colors[5][3],AffDotsOpt.transparency);
		else
			m.haunt.cd:Hide();
			m.haunt.texture:SetTexture(colors[5][1],colors[5][2],colors[5][3],AffDotsOpt.transparency);
		end
		shards = UnitPower("player", 7)
		m.haunt.t1:SetText(shards)
		if(shards == 4) then m.haunt.texture:SetTexture(colors[1][1],colors[1][2],colors[1][3],AffDotsOpt.transparency) end
	end
end

function GetRatings()
	local mas = GetMastery()*3.1;
	local has = GetRangedHaste();
	local cri = GetSpellCritChance(6);
	local dmg = GetSpellBonusDamage(6);
	if( mas ~= mastery or has ~= haste or cri ~= crit or dmg ~= spd) then
		mastery = mas;
		haste 	= has;
		crit 	= cri;
		spd 	= dmg;
		GetDotDmg();
	end
end

function TargetDots()
	if AffDotsOpt.main_text == "absolute" then
		if target_id then
			if(agony_targets[tostring(target_id)]) then
				m.agony.t2:SetText(agony_targets[tostring(target_id)][1])
			else
				m.agony.t2:SetText(0)
			end
			if(corruption_targets[tostring(target_id)]) then
				m.corr.t2:SetText(corruption_targets[tostring(target_id)][1]);
			else
				m.corr.t2:SetText(0)
			end
			if(ua_targets[tostring(target_id)]) then
				m.ua.t2:SetText(ua_targets[tostring(target_id)][1]);
			else
				m.ua.t2:SetText(0)
			end
		end
	elseif AffDotsOpt.main_text == "relative" then
		if target_id then
			if(agony_targets[tostring(target_id)] and agony_targets[tostring(target_id)][1] > 0) then
				rel = Round(agony/agony_targets[tostring(target_id)][1]*100)
				m.agony.t3:SetText(rel)
			else
				m.agony.t3:SetText(0)
			end
			if(corruption_targets[tostring(target_id)] and corruption_targets[tostring(target_id)][1] > 0) then
				rel = Round(corruption/corruption_targets[tostring(target_id)][1]*100)
				m.corr.t3:SetText(rel)
			else
				m.corr.t3:SetText(0)
			end
			if(ua_targets[tostring(target_id)] and ua_targets[tostring(target_id)][1] > 0) then
				rel = Round(ua/ua_targets[tostring(target_id)][1]*100)
				m.ua.t3:SetText(rel)
			else
				m.ua.t3:SetText(0)
			end
		end
	end
	if(focus_id and AffDotsOpt.focus) then
		if AffDotsOpt.focus_text == "absolute" then
			if(agony_targets[tostring(focus_id)]) then
				f.agony.t2:SetText(agony_targets[tostring(focus_id)][1])
			else
				f.agony.t2:SetText(0)
			end
			if(corruption_targets[tostring(focus_id)]) then
				f.corr.t2:SetText(corruption_targets[tostring(focus_id)][1]);
			else
				f.corr.t2:SetText(0)
			end
			if(ua_targets[tostring(focus_id)]) then
				f.ua.t2:SetText(ua_targets[tostring(focus_id)][1]);
			else
				f.ua.t2:SetText(0)
			end
		elseif AffDotsOpt.main_text == "relative" then
			if(agony_targets[tostring(focus_id)] and agony_targets[tostring(focus_id)][1] > 0) then
				rel = Round(agony/agony_targets[tostring(focus_id)][1]*100)
				f.agony.t3:SetText(rel)
			else
				f.agony.t3:SetText(0)
			end
			if(corruption_targets[tostring(focus_id)] and corruption_targets[tostring(focus_id)][1] > 0) then
				rel = Round(corruption/corruption_targets[tostring(focus_id)][1]*100)
				f.corr.t3:SetText(rel)
			else
				f.corr.t3:SetText(0)
			end
			if(ua_targets[tostring(focus_id)] and ua_targets[tostring(focus_id)][1] > 0) then
				rel = Round(ua/ua_targets[tostring(focus_id)][1]*100)
				f.ua.t3:SetText(rel)
			else
				f.ua.t3:SetText(0)
			end
		end
	end
end

function CleanTargets()
	local t = GetTime()
	for k,v in pairs(agony_targets) do 
		if agony_targets[k][2] < t-100 then agony_targets[k]=nil end
	end
	for k,v in pairs(corruption_targets) do
		if corruption_targets[k][2] < t-100 then corruption_targets[k]=nil end
	end
	for k,v in pairs(ua_targets) do
		if ua_targets[k][2] < t-100 then ua_targets[k]=nil end
	end
end

function onUpdate(self,elapsed)
    timer = timer + elapsed;
    if timer >= 0.2 then
		SetFrames();
		TargetDots();
        timer = 0;
    end
end

function Events()
	if(GetSpecialization()==1 and select(2, UnitClass("player")) == "WARLOCK") then
		m:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		m:RegisterEvent("PLAYER_REGEN_ENABLED")
		m:RegisterEvent("PLAYER_REGEN_DISABLED")
		m:RegisterEvent("COMBAT_RATING_UPDATE")
		m:RegisterEvent("SPELL_POWER_CHANGED")
		m:RegisterEvent("PLAYER_DAMAGE_DONE_MODS")
		m:RegisterEvent("UNIT_INVENTORY_CHANGED")
		m:RegisterEvent("UNIT_TARGET")
		m:SetScript("OnUpdate", onUpdate)
	else
		m:SetScript("OnUpdate", nil);
		m:UnregisterEvent("UNIT_INVENTORY_CHANGED")
		m:UnregisterEvent("SPELL_POWER_CHANGED")
		m:UnregisterEvent("COMBAT_RATING_UPDATE")
		m:UnregisterEvent("PLAYER_DAMAGE_DONE_MODS")
		m:UnregisterEvent("PLAYER_REGEN_DISABLED")
		m:UnregisterEvent("PLAYER_REGEN_ENABLED")
		m:UnregisterEvent("UNIT_TARGET")
		m:UnregisterEvent("PLAYER_FOCUS_CHANGED")
		m:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		m:Hide();
	end
end

function GetBonus()
	local t14_equipped	= 0
	local t14set_ids 	= { 86709, 86710, 86711, 86712, 86713,
							85369, 85370, 85371, 85372, 85373,
							87187, 87188, 87189, 87190, 87191}
	local slot_ids		= { 1, 3, 5, 6, 7, 8, 9 ,10}
	for i,v in ipairs(slot_ids) do
		local id = GetInventoryItemID("player", v)
		for j, k in ipairs(t14set_ids) do
			if k == id then
				t14_equipped = t14_equipped + 1
			end
		end
	end
	if t14_equipped >= 2 then corruption_bonus = 1.1 else corruption_bonus = 1 end
end


SLASH_AFFDOTS1 = '/affdots'
function handler(msg, editBox)
	Unlock(true)
	Hide(false)
	AffDotsOptions:Show()
end
SlashCmdList["AFFDOTS"] = handler

function VariablesLoaded()
	if(not AffDotsOpt) then AffDotsOpt = {} end
	if(not AffDotsOpt.layout) then AffDotsOpt.layout = "vertical" end
	if(not AffDotsOpt.scale) then AffDotsOpt.scale = "1" end
	if(not AffDotsOpt.agony_order) then AffDotsOpt.agony_order = 0 end
	if(not AffDotsOpt.corruption_order) then AffDotsOpt.corruption_order = 1 end
	if(not AffDotsOpt.ua_order) then AffDotsOpt.ua_order = 2 end
	if(not AffDotsOpt.haunt_order) then AffDotsOpt.haunt_order = 3 end
	if(not AffDotsOpt.haunt) then AffDotsOpt.haunt = false end
	if(not AffDotsOpt.locked) then AffDotsOpt.locked = false end
	if(not AffDotsOpt.hide) then AffDotsOpt.hide = false end
	if(not AffDotsOpt.focus) then AffDotsOpt.focus = false end
	if(not AffDotsOpt.focus_scale) then AffDotsOpt.focus_scale = 0.8 end
	if(not AffDotsOpt.color_switch) then AffDotsOpt.color_switch = 1.1 end
	if(not AffDotsOpt.main_text) then AffDotsOpt.main_text = "absolute" end
	if(not AffDotsOpt.focus_text) then AffDotsOpt.focus_text = "absolute" end
	if(not AffDotsOpt.transparency) then AffDotsOpt.transparency = 0.5 end
	if(not AffDotsOpt.color1) then AffDotsOpt.color1 = {0,0.5,0} end
	if(not AffDotsOpt.color2) then AffDotsOpt.color2 = {0,0,0.5} end
	if(not AffDotsOpt.color3) then AffDotsOpt.color3 = {0.5,0.5,0} end
	if(not AffDotsOpt.color4) then AffDotsOpt.color4 = {0.5,0,0} end
	if(not AffDotsOpt.color5) then AffDotsOpt.color5 = {0,0,0} end
	colors = {AffDotsOpt.color1,AffDotsOpt.color2,AffDotsOpt.color3,AffDotsOpt.color4,AffDotsOpt.color5}
	if AffDotsOpt.focus then
		m:RegisterEvent("PLAYER_FOCUS_CHANGED")
	end
	if(not AffDotsOpt.hide) then m:Show() end
	OptionsFrameFunctions()
	Unlock(false)
	Layout()
	m:SetScript("OnEvent", OnEvent);
end

function OnEvent(frame, event, ...)
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		_,event_type,_,source_GUID,_,_,_,dest_GUID,_,_,_,spell = select(1, ...)
		if(source_GUID == me and dest_GUID ~= me) then
			if(event_type == "SPELL_DAMAGE" and spell == 77799) then
				corruption_targets[tostring(dest_GUID)] = {corruption,GetTime()};
				ua_targets[tostring(dest_GUID)] = {ua,GetTime()}
			elseif(event_type == "SPELL_AURA_APPLIED" or event_type == "SPELL_AURA_REFRESH") then
				if(spell == 172 or spell == 87389) then
					corruption_targets[tostring(dest_GUID)] = {corruption,GetTime()}
				elseif(spell == 980) then
					agony_targets[tostring(dest_GUID)] = {agony,GetTime()}
				elseif(spell == 30108) then
					ua_targets[tostring(dest_GUID)] = {ua,GetTime()}
				end
			elseif(event_type == "SPELL_AURA_REMOVED") then
				if(spell == 172 or spell == 87389) then
					corruption_targets[tostring(dest_GUID)]=nil
				elseif(spell == 980) then
					agony_targets[tostring(dest_GUID)]=nil
				elseif(spell == 30108) then
					ua_targets[tostring(dest_GUID)]=nil
				end
			end
		end
	elseif(event == "PLAYER_DAMAGE_DONE_MODS" or event == "COMBAT_RATING_UPDATE" or event == "SPELL_POWER_CHANGED") then
		GetRatings()
	elseif event == "PLAYER_REGEN_ENABLED" then
		if(AffDotsOpt.hide) then
			m:Hide()
		end
		CleanTargets()
	elseif event == "PLAYER_REGEN_DISABLED" then
		if(AffDotsOpt.hide) then
			m:Show()
		end
	elseif event == "UNIT_TARGET" then
		target_id = UnitGUID("target")
	elseif event == "PLAYER_FOCUS_CHANGED" then
		focus_id = UnitGUID("focus")
		if(focus_id and AffDotsOpt.focus) then
			f:Show()
		else
			f:Hide()
		end
	elseif event == "UNIT_INVENTORY_CHANGED" then
		GetBonus()
		GetDotDmg()
	elseif event == "VARIABLES_LOADED" then
		VariablesLoaded()
	elseif event == "PLAYER_ENTERING_WORLD" then
		me = UnitGUID("player")
		GetBonus()
		GetRatings()
		Events()
	elseif event == "ACTIVE_TALENT_GROUP_CHANGED" then
		Events()
	end
end

m:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
m:RegisterEvent("PLAYER_ALIVE");
m:RegisterEvent("PLAYER_ENTERING_WORLD");
m:RegisterEvent("VARIABLES_LOADED");